import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
  * Einfache Implementation des Raumplaners mit Gui (nur Buttons)
  * Moebel-Objekte koennen angezeigt und Mausklick ausgewaehlt werden.
  * MVC-Anwendung: Controller - Einbau
  * Das ausgewaehlten Moebel-Objekt wird jeweils farblich gekennzeichnet.
  *
  * @version 5.0 vom 2020
  * @author claus albowski
  */


public class RaumplanerGui extends JFrame {
  // Anfang Variablen

  // Anfang Attribute
  private static RaumplanerController controller;
  private static RaumplanerGui gui;

  private JButton jButton1 = new JButton();
  private JButton jButton2 = new JButton();
  private JButton jButton3 = new JButton();
  private JButton jButton4 = new JButton();
  private JButton jButton5 = new JButton();
  private JButton jButton6 = new JButton();
  private JButton jButton7 = new JButton();
  private JButton jButton8 = new JButton();
  private JButton jButton9 = new JButton();
  // Ende Attribute

  // Ende Variablen

  public RaumplanerGui(String title) {
    // Frame-Initialisierung
    super(title);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) { System.exit(0); }
    });
    int frameWidth = 300;
    int frameHeight = 350;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2 ;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jButton1.setBounds(8, 8, 147, 25);
    jButton1.setText("Tisch");
    cp.add(jButton1);
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        neuesMoebelActionPerformed("Tisch");
      }
    });

    jButton2.setBounds(8, 40, 147, 25);
    jButton2.setText("Stuhl");
    cp.add(jButton2);
    jButton2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        neuesMoebelActionPerformed("Stuhl");
      }
    });

    jButton3.setBounds(8, 80, 147, 25);
    jButton3.setText("Schrank");
    cp.add(jButton3);
    jButton3.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        neuesMoebelActionPerformed("Schrank");
      }
    });

    jButton4.setBounds(8, 120, 147, 25);
    jButton4.setText("Tischgruppe");
    cp.add(jButton4);
    jButton4.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        neuesMoebelActionPerformed("Tischgruppe");
      }
    });

    jButton5.setBounds(8, 160, 147, 25);
    jButton5.setText("Schrankwand");
    cp.add(jButton5);
    jButton5.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        neuesMoebelActionPerformed("Schrankwand");
      }
    });

    jButton6.setBounds(8, 200, 147, 25);
    jButton6.setText("Konferenztisch");
    cp.add(jButton6);
    jButton6.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        neuesMoebelActionPerformed("Konferenztisch");
      }
    });

    jButton7.setBounds(8, 240, 243, 25);
    jButton7.setText("KonferenzTischGruppe");
    cp.add(jButton7);
    jButton7.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        neuesMoebelActionPerformed("KonferenzTischGruppe");
      }
    });

    jButton8.setBounds(176, 16, 75, 25);
    jButton8.setText("Auswahl");
    cp.add(jButton8);
    jButton8.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton8ActionPerformed(evt);
      }
    });

    jButton9.setBounds(176, 56, 75, 25);
    jButton9.setText("verschiebe");
    cp.add(jButton9);
    jButton9.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton9ActionPerformed(evt);
      }
    });

    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden

  // Anfang Ereignisprozeduren
  public void neuesMoebelActionPerformed(String typ) {
    controller.neuesMoebel(typ);
  }

  public void jButton8ActionPerformed(ActionEvent evt) {
    controller.auswahl();
  }

  public void jButton9ActionPerformed(ActionEvent evt) {
    controller.verschiebe();
  }

  // Ende Ereignisprozeduren
  // main - Methode hier lassen, damit kein Application-Fenster ge�ffnet wird.
  // Das k�nnte man nat�rlich besser machen.

  public static void main(String[] args) {
    gui = new RaumplanerGui("RaumplanerGui");
    controller= new RaumplanerController(gui);
  }
  // Ende Methoden

}

